import {Component} from 'react';

/**
 * DataList.Column component.
 * @name DataList.DataListBasic
 * @description Define the DataList column.
 * @abstract
 * @ignore
 * @since 0.1.0
 * @author liujiali
 * @property {Array} data - Component data.
 * @property {Array} columns - Component columns definition.
 * @property {Array} actions - Component actions definition.
 * @property {boolean} loading - Whether the component is loading.
 * @property {object} pagination - Component pagination settings.
 * @property {Array} filters - Component filter settings.
 * @property {Array} sorts - Component sort settings.
 * @property {onChange} onChange - Component onChange function.
 */
class DataListBasic extends Component {
}

export default DataListBasic;

/**
 * render method description.
 * @callback onChange
 * @param {Array} selectKeys - Component select keys.
 * @param {Array} filters - Component filters.
 */
