/**
 * DataList.Refresh component.
 * @memberof DataList
 * @name DataList.Refresh
 * @description Define the DataList Refresh.
 * @since 0.1.2
 * @author liujiali
 * @property {string|ReactNode} [label] - Refresh button label.
 * @example
 * <DataList>
 *     <DataList.Head>
 *         <DataList.Refresh label='Refresh' />
 *         ......
 *     </DataList.Head>
 *     ......
 * </DataList>
 */
class DataListRefresh {
    /**
     * Create and initialize component.
     * @param {*} props - Component props.
     */
    constructor(props) {
        const defaultAttrs = {
            label: props.label || null,
        };
        this.attrs = defaultAttrs;
    }
}

export default DataListRefresh;
