/**
 * DataList.Title component.
 * @memberof DataList
 * @name DataList.Title
 * @description Define the DataList title.
 * @since 0.1.2
 * @author liujiali
 * @property {string|ReactNode} [title] - DataList title.
 * @property {ReactNode} [children] - Children of DataList.Title.
 * @example
 * <DataList>
 *     <DataList.Title title='Test' />
 *     ......
 * </DataList>
 */
class DataListTitle {
    /**
     * Create and initialize component.
     * @param {*} props - Component props.
     */
    constructor(props) {
        const defaultAttrs = {
            title: null,
            children: null,
        };
        const attrs = Object.assign(defaultAttrs, props);
        this.attrs = attrs;
    };
}

export default DataListTitle;
