/**
 * Detail.Title component.
 * @memberof Detail
 * @name Detail.Title
 * @description Define the Detail column group.
 * @since 0.2.4
 * @author liujiali
 * @property {string} [title] - Detail title.
 * @property {ReactNode} [children] - Detail title children.
 * @example
 * <Detail>
 *     <Detail.Title title='Detail' />
 *     ......
 * </Detail>
 */
class DetailTitle {
    /**
     * Create and initialize component.
     * @param {*} props - Component props.
     */
    constructor(props) {
        const defaultAttrs = {
            title: null,
            children: null,
        };
        const attrs = Object.assign(defaultAttrs, props);
        this.attrs = attrs;
    }
}

export default DetailTitle;
