import React, {Fragment} from 'react';
import {Input as AntdInput} from 'antd';
import BasicComponent from './BasicComponent';

/**
 * Input component.
 * @name Input
 * @since 0.3.3
 * @author liujiali
 */
class Input extends BasicComponent {
    /**
     * Render method.
     * @return  {*} No return value.
     */
    render() {
        const {value, error} = this.state;
        return (
            <Fragment>
                <div className={error ? 'has-error' : ''}>
                    <AntdInput {...this.props} value={value}
                        onChange={this.onChange((e) => e.target.value)} />
                </div>
            </Fragment>
        );
    }
}

export default Input;
