import React, {Fragment} from 'react';
import {InputNumber as AntdInputNumber} from 'antd';
import BasicComponent from './BasicComponent';

/**
 * InputNumber component.
 * @name InputNumber
 * @since 0.3.3
 * @author liujiali
 */
class InputNumber extends BasicComponent {
    /**
     * Render method.
     * @return  {*} No return value.
     */
    render() {
        const {value, error} = this.state;
        return (
            <Fragment>
                <div className={error ? 'has-error' : ''}>
                    <AntdInputNumber style={{width: '100%'}}
                        {...this.props} value={value} onChange={this.onChange()} />
                </div>
            </Fragment>
        );
    }
}

export default InputNumber;
