import Validate from 'rc-js-validate';

/**
 * Input validate.
 * @param  {object} [options={}] - Validate options.
 * @return {boolean} validate result.
 */
function validateField(options = {}) {
    const {required, pattern, maxLen} = options;
    return (value) => {
        if (required && !Validate.required(value)) {
            return false;
        }
        if (pattern && !Validate.pattern(value, pattern)) {
            return false;
        }
        if (maxLen && !Validate.maxLen(value, maxLen)) {
            return false;
        }
        return true;
    };
}
export default validateField;
