let defaultSettings = {
    locale: navigator.language === 'zh-CN' ? 'zh' : 'en',
};
/**
 * Set rc-ui-component settings.
 * @param {object} settings - rc-ui-component settings.
 * @param {enum} [settings.locale] - rc-ui-component text locale.<br/>[`zh`, `en`].
 */
function setDefaultSettings(settings) {
    defaultSettings = Object.assign(defaultSettings, settings);
}
/**
 * Get rc-ui-component settings.
 * @return {object} rc-ui-component settings.
 */
function getDefaultSettings() {
    return defaultSettings;
}

export {setDefaultSettings};
export {getDefaultSettings};
export {default as DataList} from './DataList';
export {default as ModalHelper} from './ModalHelper';
export {default as Form} from './Form';
export {default as Detail} from './Detail';
