'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * DataList.Column component.
 * @name DataList.DataListBasic
 * @description Define the DataList column.
 * @abstract
 * @ignore
 * @since 0.1.0
 * @author liujiali
 * @property {Array} data - Component data.
 * @property {Array} columns - Component columns definition.
 * @property {Array} actions - Component actions definition.
 * @property {boolean} loading - Whether the component is loading.
 * @property {object} pagination - Component pagination settings.
 * @property {Array} filters - Component filter settings.
 * @property {Array} sorts - Component sort settings.
 * @property {onChange} onChange - Component onChange function.
 */
var DataListBasic = function (_Component) {
  _inherits(DataListBasic, _Component);

  function DataListBasic() {
    _classCallCheck(this, DataListBasic);

    return _possibleConstructorReturn(this, (DataListBasic.__proto__ || Object.getPrototypeOf(DataListBasic)).apply(this, arguments));
  }

  return DataListBasic;
}(_react.Component);

exports.default = DataListBasic;

/**
 * render method description.
 * @callback onChange
 * @param {Array} selectKeys - Component select keys.
 * @param {Array} filters - Component filters.
 */