'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.DataListFilterComponent = exports.DataListFilterItem = undefined;

var _collapse = require('antd/lib/collapse');

var _collapse2 = _interopRequireDefault(_collapse);

var _col = require('antd/lib/col');

var _col2 = _interopRequireDefault(_col);

var _row = require('antd/lib/row');

var _row2 = _interopRequireDefault(_row);

var _divider = require('antd/lib/divider');

var _divider2 = _interopRequireDefault(_divider);

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _select = require('antd/lib/select');

var _select2 = _interopRequireDefault(_select);

var _datePicker = require('antd/lib/date-picker');

var _datePicker2 = _interopRequireDefault(_datePicker);

var _tag = require('antd/lib/tag');

var _tag2 = _interopRequireDefault(_tag);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd/lib/collapse/style');

require('antd/lib/col/style');

require('antd/lib/row/style');

require('antd/lib/divider/style');

require('antd/lib/button/style');

require('antd/lib/input/style');

require('antd/lib/select/style');

require('antd/lib/date-picker/style');

require('antd/lib/tag/style');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _rcJsUtils = require('rc-js-utils');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CheckableTag = _tag2.default.CheckableTag;


var LOCALE = {
    zh: {
        filter: '过滤',
        reset: '重置',
        all: '全部',
        filterText: '过滤条件'
    },
    en: {
        filter: 'Filter',
        reset: 'Reset',
        all: 'All',
        filterText: 'Filter condition'
    }
};

/**
 * DataList.Title component.
 * @memberof DataList
 * @name DataList.Filter
 * @description Define the DataList filter.
 * @since 0.1.2
 * @author liujiali
 * @property {string} label - Filter label.
 * @property {string} dataKey - Filter data key.
 * @property {enum} [type=text] - Filter type.<br/>[`text`, `enum`, `date`, `datetime`].
 * @property {function} render - Filter value label render function.
 * @property {Array} [options] - Effextive when type=`enum`.Filter options.
 * @property {string} options.label - Option label.
 * @property {*} options.value - Option value.
 * @example
 * <DataList>
 *     <DataList.Head>
 *         <DataList.Filter>
 *             <DataList.FilterItem label='Name' dataKey='name' type='text' />
 *         </DataList.Filter>
 *     </DataList.Head>
 *     ......
 * </DataList>
 */

var DataListFilter =
/**
 * Create and initialize component.
 * @param {*} props - Component props.
 */
function DataListFilter(props) {
    _classCallCheck(this, DataListFilter);

    var defaultAttrs = {
        children: []
    };
    var children = props.children,
        _props$float = props.float,
        float = _props$float === undefined ? 'left' : _props$float,
        multiple = props.multiple;

    var insProps = {
        children: [],
        float: float,
        multiple: multiple
    };
    _react2.default.Children.map(children, function (child) {
        var type = child.type;

        var Component = type;
        var ChildIns = new Component(child.props);
        insProps.children.push(ChildIns.attrs);
    });
    this.attrs = Object.assign(defaultAttrs, insProps);
};

/**
 * DataList.Title component.
 * @memberof DataList
 * @name DataList.FilterItem
 * @description Define the DataList filter.
 * @since 0.1.2
 * @author liujiali
 * @property {string} label - Filter label.
 * @property {string} dataKey - Filter data key.
 * @property {enum} [type=text] - Filter type.<br/>[`text`, `enum`, `date`, `datetime`].
 * @property {function} render - Filter value label render function.
 * @property {Array} [options] - Effextive when type=`enum`.Filter options.
 * @property {string} options.label - Option label.
 * @property {*} options.value - Option value.
 * @example
 * <DataList>
 *     <DataList.Head>
 *         <DataList.Filter>
 *             <DataList.FilterItem label='Name' dataKey='name' type='text' />
 *             ......
 *         </DataList.Filter>
 *     </DataList.Head>
 *     ......
 * </DataList>
 */


var DataListFilterItem =
/**
 * Create and initialize component.
 * @param {*} props - Component props.
 */
function DataListFilterItem(props) {
    _classCallCheck(this, DataListFilterItem);

    var defaultAttrs = {
        label: '',
        dataKey: null,
        type: 'text'
    };
    this.attrs = Object.assign(defaultAttrs, props);
};

/**
 * DataList filter node.
 * @private
 */


var DataListFilterComponent = function (_Component) {
    _inherits(DataListFilterComponent, _Component);

    /**
     * Create and initialize component.
     * @param {*} props - Component props.
     */
    function DataListFilterComponent(props) {
        _classCallCheck(this, DataListFilterComponent);

        var _this = _possibleConstructorReturn(this, (DataListFilterComponent.__proto__ || Object.getPrototypeOf(DataListFilterComponent)).call(this, props));

        var filter = props.filter,
            multiple = props.multiple;

        if (multiple) {
            _this.state = {};
            filter.forEach(function (f) {
                var label = f.label,
                    dataKey = f.dataKey,
                    type = f.type,
                    render = f.render,
                    options = f.options;

                _this.state[dataKey] = { // eslint-disable-line
                    label: label,
                    dataKey: dataKey,
                    valueLabel: null,
                    value: null,
                    type: type,
                    render: render || _this.getFilterRender(type, options || []),
                    options: options || []
                };
            });
        } else {
            var defaultFilter = filter[0];
            var label = defaultFilter.label,
                dataKey = defaultFilter.dataKey,
                type = defaultFilter.type,
                render = defaultFilter.render,
                options = defaultFilter.options;

            _this.state = {
                label: label,
                dataKey: dataKey,
                valueLabel: null,
                value: null,
                type: type,
                render: render || _this.getFilterRender(type, options || []),
                options: options || []
            };
        }
        return _this;
    }
    /**
     * Get default filter value label render.
     * @since 0.1.4
     * @author liujiali
     * @private
     * @param {string} type - Filter type.
     * @param {Array} options - Filter options.Effective when type=`enum`.
     * @return {function} Filter value label render.
     */


    _createClass(DataListFilterComponent, [{
        key: 'getFilterRender',
        value: function getFilterRender(type, options) {
            var render = null;
            switch (type) {
                case 'date':
                    render = function render(dates) {
                        if (!dates.length) return null;
                        var start = dates[0].format('YYYY-MM-DD');
                        var end = dates[1].format('YYYY-MM-DD');
                        return start + ' ~ ' + end;
                    };
                    break;
                case 'datetime':
                    render = function render(dates) {
                        if (!dates.length) return null;
                        var start = dates[0].format('YYYY-MM-DD HH:mm:ss');
                        var end = dates[1].format('YYYY-MM-DD HH:mm:ss');
                        return start + ' ~ ' + end;
                    };
                    break;
                case 'enum':
                    render = function render(value) {
                        var result = (0, _lodash.find)(options, function (i) {
                            return i.value === value;
                        });
                        return result.label;
                    };
                    break;
                default:
                    render = function render(val) {
                        return val;
                    };
            }
            return render;
        }
        /**
         * Handle filter change.
         * @since 0.1.4
         * @author liujiali
         * @private
         * @return {function} filter select change handler.
         */

    }, {
        key: 'handleSelectChange',
        value: function handleSelectChange() {
            var _this2 = this;

            return function (dataKey) {
                var filter = _this2.props.filter;

                var current = (0, _lodash.find)(filter, function (i) {
                    return i.dataKey === dataKey;
                });
                _this2.setState({
                    label: current.label,
                    dataKey: current.dataKey,
                    valueLabel: null,
                    value: null,
                    type: current.type || 'text',
                    render: current.render || _this2.getFilterRender(current.type || 'text', current.options || []),
                    options: current.options || []
                });
            };
        }
        /**
         * Get filter component by type.
         * @since 0.2.6
         * @author liujiali
         * @private
         * @param  {enum} filterType - Component type.
         * @param  {any} model - Filter component model.
         * @return {ReactNode} - Filter component.
         */

    }, {
        key: 'getFilterComponent',
        value: function getFilterComponent(filterType, model) {
            var _this3 = this;

            var filterInput = null;
            var value = model.value,
                _model$options = model.options,
                options = _model$options === undefined ? [] : _model$options,
                dataKey = model.dataKey;

            var settings = (0, _index.getDefaultSettings)();
            var locale = settings.locale;

            switch (filterType) {
                case 'date':
                    filterInput = _react2.default.createElement(_datePicker2.default.RangePicker, { value: value,
                        onChange: function onChange(dates) {
                            _this3.handleFilterChange(dates, dataKey);
                        },
                        style: { width: 240 } });
                    break;
                case 'datetime':
                    var defaultValue = [(0, _moment2.default)('00:00:00', 'HH:mm:ss'), (0, _moment2.default)('23:59:59', 'HH:mm:ss')];
                    filterInput = _react2.default.createElement(_datePicker2.default.RangePicker, { value: value,
                        onChange: function onChange(dates) {
                            _this3.handleFilterChange(dates, dataKey);
                        },
                        style: { width: 320 },
                        format: 'YYYY-MM-DD HH:mm:ss',
                        showTime: { defaultValue: defaultValue, format: 'HH:mm:ss' } });
                    break;
                case 'enum':
                    filterInput = _react2.default.createElement(
                        _select2.default,
                        { value: value,
                            onChange: function onChange(value) {
                                _this3.handleFilterChange(value, dataKey);
                            },
                            style: { minWidth: 200 } },
                        options.map(function (opt) {
                            return _react2.default.createElement(
                                _select2.default.Option,
                                { value: opt.value,
                                    key: opt.value },
                                opt.label
                            );
                        })
                    );
                    break;
                case 'multiple':
                    var onTagsSelect = function onTagsSelect(val, checked) {
                        var currentValue = [].concat(value || []);
                        if (!checked) {
                            var index = value.indexOf(val);
                            currentValue.splice(index, 1);
                        } else {
                            currentValue.push(val);
                        }
                        _this3.handleFilterChange(currentValue.length ? currentValue : null, dataKey);
                    };
                    var onSelectAll = function onSelectAll(checked) {
                        var currentValue = [];
                        if (checked) {
                            currentValue = options.map(function (opt) {
                                return opt.value;
                            });
                        }
                        _this3.handleFilterChange(checked ? currentValue : null, dataKey);
                    };
                    var checkedList = value || [];
                    filterInput = _react2.default.createElement(
                        _react.Fragment,
                        null,
                        _react2.default.createElement(
                            CheckableTag,
                            {
                                checked: checkedList.length === options.length,
                                onChange: function onChange(checked) {
                                    return onSelectAll(checked);
                                } },
                            LOCALE[locale].all
                        ),
                        options.map(function (opt, index) {
                            return _react2.default.createElement(
                                CheckableTag,
                                {
                                    key: index,
                                    checked: checkedList.indexOf(opt.value) > -1,
                                    onChange: function onChange(checked) {
                                        onTagsSelect(opt.value, checked);
                                    } },
                                opt.label
                            );
                        })
                    );
                    break;
                default:
                    filterInput = _react2.default.createElement(_input2.default, { value: value,
                        style: { width: 200 },
                        onChange: function onChange(e) {
                            _this3.handleFilterChange(e.target.value, dataKey);
                        } });
            }
            return filterInput;
        }
        /**
         * Get filter input component.
         * @since 0.1.4
         * @author liujiali
         * @private
         * @param {string} filterType - Filter type.
         * @return {ReactNode} Filter input node.
         */

    }, {
        key: 'renderFilterInput',
        value: function renderFilterInput(filterType) {
            return _react2.default.createElement(
                _input2.default.Group,
                { compact: true, style: { width: 'auto' } },
                this.getFilterComponent(filterType, this.state),
                _react2.default.createElement(_button2.default, { type: 'primary',
                    icon: 'search',
                    onClick: this.handleSearch() })
            );
        }
        /**
         * Handle filter input change.
         * @since 0.1.4
         * @author liujiali
         * @private
         * @param {*} value - Filter value.
         * @param {string} dataKey - Component data key.
         */

    }, {
        key: 'handleFilterChange',
        value: function handleFilterChange(value, dataKey) {
            var multiple = this.props.multiple;

            if (multiple) {
                var targetState = this.state[dataKey];
                var render = targetState.render;

                this.setState(_defineProperty({}, dataKey, _extends({}, targetState, {
                    value: value,
                    valueLabel: (0, _rcJsUtils.exec)(render, value)
                })));
            } else {
                this.setState({
                    value: value,
                    valueLabel: (0, _rcJsUtils.exec)(this.state.render, value)
                });
            }
        }
        /**
         * Handle filter button click.
         * @since 0.1.4
         * @author liujiali
         * @private
         * @return {function} Filter button click handler.
         */

    }, {
        key: 'handleSearch',
        value: function handleSearch() {
            var _this4 = this;

            return function () {
                var emptyVal = (0, _rcJsUtils.isBlank)(_this4.state.value);
                // type=`date` or type=`datetime`
                var emptyArray = _this4.state.value.length === 0;
                if (emptyVal || emptyArray) return;
                var onSearch = _this4.props.onSearch;

                (0, _rcJsUtils.exec)(onSearch, _this4.state);
                _this4.setState({
                    value: null,
                    valueLabel: null
                });
            };
        }
        /**
         * Handle filter button click.
         * @since 0.2.6
         * @author liujiali
         * @private
         * @return {function} Filter button click handler.
         */

    }, {
        key: 'handleMultipleSearch',
        value: function handleMultipleSearch() {
            var _this5 = this;

            return function (e) {
                e.stopPropagation();
                var onMultipleSearch = _this5.props.onMultipleSearch;

                var filters = [];
                for (var key in _this5.state) {
                    if (!(0, _rcJsUtils.isBlank)(_this5.state[key].value)) {
                        filters.push(_this5.state[key]);
                    }
                }
                (0, _rcJsUtils.exec)(onMultipleSearch, filters);
            };
        }
        /**
         * Handle reset button click.
         * @since 0.2.6
         * @author liujiali
         * @private
         * @return {function} Reset button click handler.
         */

    }, {
        key: 'handleResetFilterFields',
        value: function handleResetFilterFields() {
            var _this6 = this;

            return function (e) {
                e.stopPropagation();
                var nextState = {};
                for (var key in _this6.state) {
                    if (key) {
                        nextState[key] = _extends({}, _this6.state[key], {
                            value: null,
                            valueLabel: null
                        });
                    }
                }
                _this6.setState(_extends({}, nextState));
            };
        }
        /**
         * Render single filter.
         * @since 0.2.6
         * @author liujiali
         * @private
         * @return {ReactNode} - Single filter component.
         */

    }, {
        key: 'renderSingleFilter',
        value: function renderSingleFilter() {
            var filter = this.props.filter;
            var _state = this.state,
                dataKey = _state.dataKey,
                type = _state.type;

            var filterType = type || filter[0].type;
            var select = _react2.default.createElement(
                _select2.default,
                { defaultValue: dataKey,
                    dropdownMatchSelectWidth: false,
                    onChange: this.handleSelectChange(),
                    style: { marginRight: 5 } },
                filter.map(function (ftr) {
                    return _react2.default.createElement(
                        _select2.default.Option,
                        { value: ftr.dataKey, key: ftr.dataKey },
                        ftr.label
                    );
                })
            );
            return _react2.default.createElement(
                _react.Fragment,
                null,
                select,
                this.renderFilterInput(filterType)
            );
        }
        /**
         * Handle event stopPropagation;
         * @since 0.4.5
         * @author liujiali
         * @private
         * @return {function} - Event handler.
         */

    }, {
        key: 'handleCollaspe',
        value: function handleCollaspe() {
            return function (e) {
                if (e.target.nodeName !== 'SPAN') {
                    e.stopPropagation();
                }
            };
        }
        /**
         * Render multiple filter.
         * @since 0.2.6
         * @author liujiali
         * @private
         * @return {ReactNode} - Multiple filter component.
         */

    }, {
        key: 'renderMultipleFilter',
        value: function renderMultipleFilter() {
            var _this7 = this;

            var filter = this.props.filter;

            var colList = [];
            var rowCol = [];
            filter.forEach(function (f, index) {
                var _f$span = f.span,
                    span = _f$span === undefined ? 3 : _f$span;

                var rowSpan = rowCol.reduce(function (total, currentValue) {
                    total += currentValue.span || 3;
                    return total;
                }, 0);
                if (rowSpan + span > 3) {
                    colList.push([].concat(rowCol));
                    rowCol = [];
                }
                rowCol.push(f);
                if (index >= filter.length - 1) {
                    colList.push(rowCol);
                }
            });
            var settings = (0, _index.getDefaultSettings)();
            var locale = settings.locale;

            var lineStyle = {
                padding: '5px 8px',
                borderBottom: '1px solid #fff'
            };
            var colStyle = {
                display: 'flex',
                height: 42,
                alignItems: 'center',
                padding: '0 10px'
            };
            var collapseStyle = {
                margin: '-12px -16px -12px -24px',
                padding: '12px 16px 12px 24px',
                cursor: 'default'
            };
            return _react2.default.createElement(
                _react.Fragment,
                null,
                _react2.default.createElement(
                    _collapse2.default,
                    { bordered: false, className: 'rc-dataList-filter' },
                    _react2.default.createElement(
                        _collapse2.default.Panel,
                        { header: _react2.default.createElement(
                                _row2.default,
                                { type: 'flex', align: 'middle',
                                    style: collapseStyle, onClick: this.handleCollaspe() },
                                _react2.default.createElement(
                                    'span',
                                    { style: { cursor: 'pointer' } },
                                    LOCALE[locale].filterText
                                ),
                                _react2.default.createElement(_divider2.default, { type: 'vertical' }),
                                _react2.default.createElement(
                                    _button2.default,
                                    {
                                        icon: 'filter'
                                        // type='primary'
                                        , onClick: this.handleMultipleSearch() },
                                    LOCALE[locale].filter
                                ),
                                _react2.default.createElement(
                                    _button2.default,
                                    { style: { marginLeft: 10 },
                                        icon: 'rest',
                                        onClick: this.handleResetFilterFields() },
                                    LOCALE[locale].reset
                                )
                            ) },
                        _react2.default.createElement(
                            _row2.default,
                            { style: { background: '#f5f5f5', marginBottom: 10 } },
                            colList.map(function (row, index) {
                                return _react2.default.createElement(
                                    _row2.default,
                                    { style: lineStyle, key: index },
                                    row.map(function (col, index) {
                                        var _col$labelWidth = col.labelWidth,
                                            labelWidth = _col$labelWidth === undefined ? 80 : _col$labelWidth,
                                            _col$colSpan = col.colSpan,
                                            colSpan = _col$colSpan === undefined ? 8 : _col$colSpan;

                                        var width = 'calc(100% - ' + labelWidth + 'px)';
                                        return _react2.default.createElement(
                                            _col2.default,
                                            { span: colSpan, style: colStyle, key: index },
                                            _react2.default.createElement(
                                                _col2.default,
                                                { span: 1, style: { width: labelWidth } },
                                                col.label,
                                                ':'
                                            ),
                                            _react2.default.createElement(
                                                _col2.default,
                                                { span: 1, style: { width: width } },
                                                _this7.getFilterComponent(col.type, _this7.state[col.dataKey])
                                            )
                                        );
                                    })
                                );
                            })
                        )
                    )
                )
            );
        }
        /**
         * render method.
         * @return {*} No return value.
         */

    }, {
        key: 'render',
        value: function render() {
            var multiple = this.props.multiple;

            return multiple ? this.renderMultipleFilter() : this.renderSingleFilter();
        }
    }]);

    return DataListFilterComponent;
}(_react.Component);

exports.default = DataListFilter;
exports.DataListFilterItem = DataListFilterItem;
exports.DataListFilterComponent = DataListFilterComponent;