'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DataListRefresh = require('./DataListRefresh');

var _DataListRefresh2 = _interopRequireDefault(_DataListRefresh);

var _DataListFilter = require('./DataListFilter');

var _DataListFilter2 = _interopRequireDefault(_DataListFilter);

var _DataListAction = require('./DataListAction');

var _DataListAction2 = _interopRequireDefault(_DataListAction);

var _DataListActionMenu = require('./DataListActionMenu');

var _DataListActionMenu2 = _interopRequireDefault(_DataListActionMenu);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * DataList.Title component.
 * @memberof DataList
 * @name DataList.Head
 * @description Define the DataList head.
 * @since 0.1.2
 * @author liujiali
 * @property {ReactNode} [children] - Children of DataList.Title.
 * @example
 * <DataList>
 *     <DataList.Head>
 *         ......
 *     </DataList.Head>
 *     ......
 * </DataList>
 */
var DataListHead = function () {
    /**
     * Create and initialize component.
     * @param {*} props - Component props.
     */
    function DataListHead(props) {
        _classCallCheck(this, DataListHead);

        var defaultAttrs = [];
        var attrs = this.getChildrenProps(props);
        this.attrs = Object.assign(defaultAttrs, attrs);
    }
    /**
     * Get DataList.Head props.
     * @param {object} props - DataList.Head props.
     * @return {object} DataList head props.
     */


    _createClass(DataListHead, [{
        key: 'getChildrenProps',
        value: function getChildrenProps(props) {
            var children = props.children;

            var componentOrder = [];
            _react2.default.Children.map(children, function (child) {
                var ChildComponent = child.type;
                var childIns = new ChildComponent(child.props);
                if (childIns instanceof _DataListRefresh2.default) {
                    componentOrder.push({ type: 'refresh', attrs: childIns.attrs });
                } else if (childIns instanceof _DataListFilter2.default) {
                    componentOrder.push({ type: 'filter', attrs: childIns.attrs });
                } else if (childIns instanceof _DataListAction2.default) {
                    componentOrder.push({ type: 'action', attrs: childIns.attrs });
                } else if (childIns instanceof _DataListActionMenu2.default) {
                    componentOrder.push({ type: 'menu', attrs: childIns.attrs });
                } else {
                    componentOrder.push({ type: 'action', attrs: childIns });
                };
            });
            return componentOrder;
        }
    }]);

    return DataListHead;
}();

exports.default = DataListHead;