"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * DataList.Refresh component.
 * @memberof DataList
 * @name DataList.Refresh
 * @description Define the DataList Refresh.
 * @since 0.1.2
 * @author liujiali
 * @property {string|ReactNode} [label] - Refresh button label.
 * @example
 * <DataList>
 *     <DataList.Head>
 *         <DataList.Refresh label='Refresh' />
 *         ......
 *     </DataList.Head>
 *     ......
 * </DataList>
 */
var DataListRefresh =
/**
 * Create and initialize component.
 * @param {*} props - Component props.
 */
function DataListRefresh(props) {
    _classCallCheck(this, DataListRefresh);

    var defaultAttrs = {
        label: props.label || null
    };
    this.attrs = defaultAttrs;
};

exports.default = DataListRefresh;