"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _table = require("antd/lib/table");

var _table2 = _interopRequireDefault(_table);

var _tooltip = require("antd/lib/tooltip");

var _tooltip2 = _interopRequireDefault(_tooltip);

var _dropdown = require("antd/lib/dropdown");

var _dropdown2 = _interopRequireDefault(_dropdown);

var _icon = require("antd/lib/icon");

var _icon2 = _interopRequireDefault(_icon);

var _menu = require("antd/lib/menu");

var _menu2 = _interopRequireDefault(_menu);

var _divider = require("antd/lib/divider");

var _divider2 = _interopRequireDefault(_divider);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require("antd/lib/table/style");

require("antd/lib/tooltip/style");

require("antd/lib/dropdown/style");

require("antd/lib/icon/style");

require("antd/lib/menu/style");

require("antd/lib/divider/style");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _DataListBasic2 = require("./DataListBasic");

var _DataListBasic3 = _interopRequireDefault(_DataListBasic2);

var _rcJsUtils = require("rc-js-utils");

var _lodash = require("lodash");

var _index = require("../index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LOCALE = {
  zh: {
    columnActionTitle: "操作",
    columnActionMore: "更多",
    noData: "暂无数据"
  },
  en: {
    columnActionTitle: "Action",
    columnActionMore: "More",
    noData: "No Data"
  }
};

var displayActions = 3;
/**
 * @name DataListTable
 * @description DataList Table.
 * @since 0.1.0
 * @author liujiali
 * @private
 */

var DataListTable = function (_DataListBasic) {
  _inherits(DataListTable, _DataListBasic);

  /**
   * Create and initialize component.
   * @param {*} props - Component props.
   */
  function DataListTable(props) {
    _classCallCheck(this, DataListTable);

    var _this = _possibleConstructorReturn(this, (DataListTable.__proto__ || Object.getPrototypeOf(DataListTable)).call(this, props));

    _this.state = {};
    return _this;
  }
  /**
   * Convert columns to antd Table columns definition.
   * @since 0.1.0
   * @author liujiali
   * @param {Array} columns - DataList columns definitons.
   * @return {Array} antd Table columns definition.
   */


  _createClass(DataListTable, [{
    key: "convertColumn",
    value: function convertColumn(columns) {
      var _this2 = this;

      return columns.map(function (col) {
        var _render = col.render || col.convert;
        var instance = _this2.props.instance;

        return _extends({}, col, {
          title: col.label,
          key: col.dataKey,
          dataIndex: col.dataKey,
          render: function render(val, record, index) {
            return (0, _rcJsUtils.exec)(_render, val, record, index, instance);
          },
          sorter: col.sort,
          defaultSortOrder: col.defaultSort
        });
      });
    }
    /**
     * Convert actions to antd Table column.
     * @since 0.1.0
     * @author liujiali
     * @param {Array} actions - DataList actions definitons.
     * @return {object} antd Table columns definition.
     */

  }, {
    key: "convertAction",
    value: function convertAction(actions) {
      if (!actions.length) return [];
      var settings = (0, _index.getDefaultSettings)();
      var locale = settings.locale;

      var actionColumn = {
        title: LOCALE[locale].columnActionTitle,
        dataIndex: "DataList.Action",
        key: "DataList.Action",
        render: this.renderAction(actions),
        width: this.getActionWidth(actions)
      };
      return actionColumn;
    }
    /**
     * Return `render` method for action column.
     * @this DataListTable
     * @since 0.1.0
     * @author liujiali
     * @param {Array} actions - DataList actions.
     * @return {render} antd Table columns render function.
     *                  <br/>For more detail, please see https://ant.design/components/table-cn/#Column
     */

  }, {
    key: "renderAction",
    value: function renderAction(actions) {
      var _this3 = this;

      return function (value, record, index) {
        var settings = (0, _index.getDefaultSettings)();
        var locale = settings.locale;

        var actionMenus = [];
        // Whether to fold part of the actions
        var columnActionCollapse = actions.length > displayActions;
        // Get display actions
        var columnActionList = actions.slice(0, columnActionCollapse ? displayActions - 1 : displayActions);
        columnActionList.forEach(function (colAction, i) {
          if (i) {
            actionMenus.push(_react2.default.createElement(_divider2.default, { type: "vertical", key: i + 100 }));
          }
          actionMenus.push(_this3.renderActionItem(record, index, colAction, i));
        });
        // Set the actions in 'More' menu
        if (columnActionCollapse) {
          var moreMenuList = actions.slice(2);
          var moreLocaleText = LOCALE[locale].columnActionMore;
          var moreMenu = _react2.default.createElement(
            _menu2.default,
            null,
            moreMenuList.map(function (menu, i) {
              return _react2.default.createElement(
                _menu2.default.Item,
                { key: i },
                _this3.renderActionItem(record, index, menu, i)
              );
            })
          );
          actionMenus.push(_react2.default.createElement(_divider2.default, { type: "vertical", key: 200 }));
          // `+ value` is just to prevent eslint error.
          actionMenus.push(_react2.default.createElement(
            _dropdown2.default,
            { overlay: moreMenu, key: 201 },
            _react2.default.createElement(
              "a",
              null,
              moreLocaleText,
              " ",
              _react2.default.createElement(_icon2.default, { type: "down" })
            )
          ));
        }
        return actionMenus;
      };
    }
    /**
     * Render DataList action.
     * @since 0.1.0
     * @author liujiali
     * @param {object} record - Column record.
     * @param {number} index - Column record index.
     * @param {object} action - Action definition.
     * @param {number} i - Action index.
     * @return {ReactNode} ReactNode for DataList action.
     */

  }, {
    key: "renderActionItem",
    value: function renderActionItem(record, index, action, i) {
      var disabled = action.disabled;

      disabled = (0, _rcJsUtils.exec)(disabled, record, index);
      var message = disabled.isDisabled ? disabled.message : null;
      var disabledResult = (0, _lodash.isBoolean)(disabled) ? disabled : disabled && disabled.isDisabled;
      return _react2.default.createElement(
        _tooltip2.default,
        { title: message, key: i },
        disabledResult ? _react2.default.createElement(
          "span",
          null,
          _react2.default.createElement(
            "a",
            { disabled: true },
            action.label
          )
        ) : _react2.default.createElement(
          "span",
          null,
          _react2.default.createElement(
            "a",
            {
              onClick: function onClick() {
                return action.onClick(record, index);
              }
            },
            action.label
          )
        )
      );
    }
    /**
     * Calculate actions width by string length.
     * @since 0.1.0
     * @author liujiali
     * @param {Array} actions - DataList actions.
     * @return {number} DataList action labels width.
     */

  }, {
    key: "getActionWidth",
    value: function getActionWidth(actions) {
      var settings = (0, _index.getDefaultSettings)();
      var locale = settings.locale;

      var displayActionStr = "";
      var actionCollapse = actions.length > displayActions;
      var actionLabels = actions.slice(0, actionCollapse ? displayActions - 1 : displayActions).map(function (i) {
        return i.label;
      });
      // Resolve `More <Icon type='down' />` width
      var moreStr = LOCALE[locale].columnActionMore;
      if (actionCollapse) actionLabels.push(moreStr + " DD");
      actionLabels.forEach(function (act, index) {
        // Resolve `<Divider type='vertical' />` width
        if (index) {
          displayActionStr += "  ";
        }
        displayActionStr += act;
      });
      // Get action label length
      var actionLen = (0, _rcJsUtils.getStrLength)(displayActionStr) * 8;
      // Resolve `td` padding
      actionLen += 16 * 2;
      return actionLen > 120 ? actionLen : 120;
    }
    /**
     * antd Table onChange hook function.
     * @since 0.1.0
     * @author liujiali
     * @return {function} antd Table onChange handle function.
     */

  }, {
    key: "onChange",
    value: function onChange() {
      var _props = this.props,
          onChange = _props.onChange,
          pagination = _props.pagination,
          filters = _props.filters;

      return function (tablePagination, tableFilters, tableSorter) {
        var DataListPagination = {
          currentPage: tablePagination.current,
          pageSize: tablePagination.pageSize,
          total: pagination.total
        };
        var DataListFilters = filters;
        var DataListSorts = (0, _lodash.isEmpty)(tableSorter) ? [] : [{
          key: tableSorter.columnKey,
          value: tableSorter.order
        }];
        (0, _rcJsUtils.exec)(onChange, DataListPagination, DataListFilters, DataListSorts);
      };
    }

    /**
     * Render method.
     * @since 0.1.0
     * @return {*} No return value.
     */

  }, {
    key: "render",
    value: function render() {
      var _props2 = this.props,
          data = _props2.data,
          columns = _props2.columns,
          actions = _props2.actions,
          loading = _props2.loading,
          pagination = _props2.pagination,
          onSelect = _props2.onSelect,
          selectedKeys = _props2.selectedKeys;

      var settings = (0, _index.getDefaultSettings)();
      var locale = settings.locale;

      var tableColumns = this.convertColumn(columns);
      var columnActions = this.convertAction(actions);
      var showTableColumns = tableColumns.concat(columnActions);
      var rowSelection = this.props.rowSelection;

      rowSelection = (0, _lodash.isString)(rowSelection) ? { type: rowSelection } : rowSelection;
      var tableRowSelection = (0, _lodash.clone)(rowSelection);
      if (rowSelection) {
        tableRowSelection.onChange = onSelect;
        tableRowSelection.selectedRowKeys = selectedKeys;
      }
      return _react2.default.createElement(_table2.default, _extends({
        bordered: true
      }, this.props, {
        columns: showTableColumns,
        dataSource: data,
        loading: loading,
        locale: { emptyText: LOCALE[locale].noData },
        pagination: pagination,
        rowSelection: tableRowSelection,
        onChange: this.onChange()
      }));
    }
  }]);

  return DataListTable;
}(_DataListBasic3.default);

exports.default = DataListTable;