"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * DataList.Title component.
 * @memberof DataList
 * @name DataList.Title
 * @description Define the DataList title.
 * @since 0.1.2
 * @author liujiali
 * @property {string|ReactNode} [title] - DataList title.
 * @property {ReactNode} [children] - Children of DataList.Title.
 * @example
 * <DataList>
 *     <DataList.Title title='Test' />
 *     ......
 * </DataList>
 */
var DataListTitle =
/**
 * Create and initialize component.
 * @param {*} props - Component props.
 */
function DataListTitle(props) {
    _classCallCheck(this, DataListTitle);

    var defaultAttrs = {
        title: null,
        children: null
    };
    var attrs = Object.assign(defaultAttrs, props);
    this.attrs = attrs;
};

exports.default = DataListTitle;