"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Detail.Title component.
 * @memberof Detail
 * @name Detail.Title
 * @description Define the Detail column group.
 * @since 0.2.4
 * @author liujiali
 * @property {string} [title] - Detail title.
 * @property {ReactNode} [children] - Detail title children.
 * @example
 * <Detail>
 *     <Detail.Title title='Detail' />
 *     ......
 * </Detail>
 */
var DetailTitle =
/**
 * Create and initialize component.
 * @param {*} props - Component props.
 */
function DetailTitle(props) {
    _classCallCheck(this, DetailTitle);

    var defaultAttrs = {
        title: null,
        children: null
    };
    var attrs = Object.assign(defaultAttrs, props);
    this.attrs = attrs;
};

exports.default = DetailTitle;