'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FormBasicInput = require('./FormBasicInput');

var _FormBasicInput2 = _interopRequireDefault(_FormBasicInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * FormCustom component.
 * @memberof Form
 * @name Form.Custom
 * @description Custom component.
 * @since 0.2.5
 * @author liujiali
 * @private
 * @borrows FormBasicInput as Form.Custom
 * @example
 * <Form ref={(ins) => this.form = ins}>
 *     <Form.Number label='Count' dataKey='count' />
 *     ......
 * </Form>
*/
var FormCustom = function (_FormItem) {
    _inherits(FormCustom, _FormItem);

    function FormCustom() {
        _classCallCheck(this, FormCustom);

        return _possibleConstructorReturn(this, (FormCustom.__proto__ || Object.getPrototypeOf(FormCustom)).apply(this, arguments));
    }

    _createClass(FormCustom, [{
        key: 'render',

        /**
         * Render method.
         * @since 0.2.5
         * @author liujiali
         * @private
         * @return  {*} No return value.
         */
        value: function render() {
            var _props = this.props,
                component = _props.component,
                children = _props.children,
                hander = _props.hander;

            var child = component || children;
            var props = child.props,
                type = child.type;

            var Component = type;
            return _react2.default.createElement(Component, _extends({}, props, {
                value: this.state.value,
                onChange: this.handleChange(hander) }));
        }
    }]);

    return FormCustom;
}(_FormBasicInput.FormItem);

exports.default = (0, _FormBasicInput2.default)()(FormCustom);