'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _select = require('antd/lib/select');

var _select2 = _interopRequireDefault(_select);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd/lib/form/style');

require('antd/lib/select/style');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _utils = require('./_utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var labelProps = ['colon', 'extra', 'hasFeedback', 'help', 'label', 'labelCol', 'required', 'validateStatus', 'wrapperCol'];

var componentProps = ['allowClear', 'autoClearSearchValue', 'autoFocus', 'defaultActiveFirstOption', 'disabled', 'dropdownClassName', 'dropdownMatchSelectWidth', 'dropdownRender', 'dropdownStyle', 'filterOption', 'firstActiveValue', 'getPopupContainer', 'labelInValue', 'maxTagCount', 'maxTagPlaceholder', 'mode', 'notFoundContent', 'optionFilterProp', 'optionLabelProp', 'placeholder', 'showArrow', 'showSearch', 'size', 'suffixIcon', 'removeIcon', 'clearIcon', 'menuItemSelectedIcon', 'tokenSeparators', 'loading', 'open', 'defaultOpen'];

/**
 * FormSelect component.
 * @memberof Form
 * @name Form.Select
 * @description Select component.
 * @since 0.2.1
 * @author liujiali
 * @private
 * @example
 * <Form ref={(ins) => this.form = ins}>
 *     <Form.Select label='Name' dataKey='name' options={[]} />
 *     ......
 * </Form>
*/

var FormSelect = function (_Component) {
    _inherits(FormSelect, _Component);

    function FormSelect() {
        _classCallCheck(this, FormSelect);

        return _possibleConstructorReturn(this, (FormSelect.__proto__ || Object.getPrototypeOf(FormSelect)).apply(this, arguments));
    }

    _createClass(FormSelect, [{
        key: 'render',

        /**
         * Render method.
         * @private
         * @return  {*} No return value.
         */
        value: function render() {
            var _props = this.props,
                getFieldDecorator = _props.form.getFieldDecorator,
                dataKey = _props.dataKey,
                _props$options = _props.options,
                options = _props$options === undefined ? [] : _props$options;

            var labelProp = (0, _lodash.pick)(this.props, labelProps);
            var componentProp = (0, _lodash.pick)(this.props, componentProps);
            var rules = (0, _utils.getComponentValidate)(this.props);
            var formOptions = (0, _utils.getComponentOptions)(this.props);
            formOptions.rules = rules;
            return _react2.default.createElement(
                _form2.default.Item,
                labelProp,
                getFieldDecorator(dataKey, formOptions)(_react2.default.createElement(
                    _select2.default,
                    componentProp,
                    options.map(function (opt) {
                        return _react2.default.createElement(
                            _select2.default.Option,
                            { key: opt.value },
                            opt.label
                        );
                    })
                ))
            );
        }
    }]);

    return FormSelect;
}(_react.Component);

exports.default = FormSelect;