'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _input = require('antd/lib/input');

var _input2 = _interopRequireDefault(_input);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd/lib/form/style');

require('antd/lib/input/style');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _utils = require('./_utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var labelProps = ['colon', 'extra', 'hasFeedback', 'help', 'label', 'labelCol', 'required', 'validateStatus', 'wrapperCol'];

var componentProps = ['addonAfter', 'addonBefore', 'disabled', 'id', 'prefix', 'size', 'suffix', 'type', 'onPressEnter', 'allowClear'];

/**
 * FormText component.
 * @memberof Form
 * @name Form.Text
 * @description Input component.
 * @since 0.2.1
 * @author liujiali
 * @private
 * @example
 * <Form ref={(ins) => this.form = ins}>
 *     <Form.Text label='Name' dataKey='name' />
 *     ......
 * </Form>
*/

var FormText = function (_Component) {
    _inherits(FormText, _Component);

    function FormText() {
        _classCallCheck(this, FormText);

        return _possibleConstructorReturn(this, (FormText.__proto__ || Object.getPrototypeOf(FormText)).apply(this, arguments));
    }

    _createClass(FormText, [{
        key: 'render',

        /**
         * Render method.
         * @private
         * @return  {*} No return value.
         */
        value: function render() {
            var _props = this.props,
                getFieldDecorator = _props.form.getFieldDecorator,
                dataKey = _props.dataKey;

            var labelProp = (0, _lodash.pick)(this.props, labelProps);
            var componentProp = (0, _lodash.pick)(this.props, componentProps);
            var rules = (0, _utils.getComponentValidate)(this.props);
            var formOptions = (0, _utils.getComponentOptions)(this.props);
            formOptions.rules = rules;
            return _react2.default.createElement(
                _form2.default.Item,
                labelProp,
                getFieldDecorator(dataKey, formOptions)(_react2.default.createElement(_input2.default, componentProp))
            );
        }
    }]);

    return FormText;
}(_react.Component);

exports.default = FormText;