'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getComponentOptions = exports.getComponentValidate = undefined;

var _lodash = require('lodash');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var rules = ['enum', 'len', 'max', 'min', 'pattern', 'required', 'transform', 'type', 'validator', 'whitespace'];

var options = ['getValueFromEvent', 'initialValue', 'normalize', 'preserve', 'trigger', 'validateFirst', 'validateTrigger', 'valuePropName'];
/**
 * Return component validate by props.
 * @param {object} props Component props.
 * @return {Array} Component validate rule list.
 */
function getComponentValidate(props) {
    var ruleList = (0, _lodash.pick)(props, rules);
    var message = props.message;

    var rule = [];
    // eslint-disable-next-line guard-for-in
    for (var validate in ruleList) {
        var _rule$push;

        rule.push((_rule$push = {}, _defineProperty(_rule$push, validate, ruleList[validate]), _defineProperty(_rule$push, 'message', (0, _lodash.isObject)(message) ? message[validate] : message), _rule$push));
    }
    return rule;
}
/**
 * Return `getFieldDecorator` function options.
 * @param {object} props Component props.
 * @return {object} `getFieldDecorator` options.
 */
function getComponentOptions(props) {
    var option = (0, _lodash.pick)(props, options);
    return option;
}

exports.getComponentValidate = getComponentValidate;
exports.getComponentOptions = getComponentOptions;