'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _form = require('antd/lib/form');

var _form2 = _interopRequireDefault(_form);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd/lib/form/style');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _rcJsUtils = require('rc-js-utils');

var _FormText = require('./FormText');

var _FormText2 = _interopRequireDefault(_FormText);

var _FormTextArea = require('./FormTextArea');

var _FormTextArea2 = _interopRequireDefault(_FormTextArea);

var _FormNumber = require('./FormNumber');

var _FormNumber2 = _interopRequireDefault(_FormNumber);

var _FormSelect = require('./FormSelect');

var _FormSelect2 = _interopRequireDefault(_FormSelect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var formProps = ['hideRequiredMark', 'labelAlign', 'labelCol', 'layout', 'onSubmit', 'wrapperCol', 'colon'];

var defaultFormLayout = {
    labelCol: { span: 2 },
    wrapperCol: { span: 10, offset: 0.5 }
};

/**
 * Form component.
 * @memberof Form
 * @description Form component.
 * @since 0.2.1
 * @author liujiali
 * @private
 * @example
 * <Form ref={(ins) => this.form = ins}>
 *     <Form.Number label='Name' dataKey='name' />
 *     ......
 * </Form>
*/

var Form = function (_Component) {
    _inherits(Form, _Component);

    function Form() {
        _classCallCheck(this, Form);

        return _possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).apply(this, arguments));
    }

    _createClass(Form, [{
        key: 'render',

        /**
         * Render method.
         * @private
         * @return  {*} No return value.
         */
        value: function render() {
            var _props = this.props,
                children = _props.children,
                form = _props.form;

            var component = [];
            var formValues = form.getFieldsValue();
            _react2.default.Children.map(children, function (child) {
                var props = child.props,
                    type = child.type;

                var Component = type;
                var visible = props.visible,
                    dataKey = props.dataKey;

                var formValue = formValues[dataKey];
                if (!(0, _rcJsUtils.isBlank)(visible) && !(0, _rcJsUtils.exec)(visible, formValue, formValues)) {
                    return;
                }
                component.push(_react2.default.createElement(Component, _extends({}, props, { form: form })));
            });
            var formProp = (0, _lodash.pick)(this.props, formProps);
            return _react2.default.createElement(
                _form2.default,
                _extends({}, defaultFormLayout, { labelAlign: 'left' }, formProp),
                component
            );
        }
    }]);

    return Form;
}(_react.Component);

Form.Text = _FormText2.default;
Form.TextArea = _FormTextArea2.default;
Form.Number = _FormNumber2.default;
Form.Select = _FormSelect2.default;
exports.default = _form2.default.create()(Form);