'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _validate = require('./validate');

var _validate2 = _interopRequireDefault(_validate);

var _rcJsUtils = require('rc-js-utils');

var _rxjs = require('rxjs');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Input basic component.
 * @name BasicComponent
 * @since 0.3.3
 * @author liujiali
 */
var BasicComponent = function (_Component) {
    _inherits(BasicComponent, _Component);

    /**
     * Create and initialize component.
     * @param {*} props - Component props.
     */
    function BasicComponent(props) {
        _classCallCheck(this, BasicComponent);

        var _this = _possibleConstructorReturn(this, (BasicComponent.__proto__ || Object.getPrototypeOf(BasicComponent)).call(this, props));

        var initValue = props.initValue;

        _this.state = {
            value: initValue,
            error: false
        };
        _this.validate = (0, _validate2.default)(props);
        return _this;
    }
    /**
     * componentDidMount hook function.
     * @private
     */


    _createClass(BasicComponent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this2 = this;

            var _props = this.props,
                trigger = _props.trigger,
                onChange = _props.onChange;

            if (trigger instanceof _rxjs.Subject) {
                trigger.subscribe(function () {
                    var value = _this2.state.value;

                    var error = false;
                    if (!_this2.validate(value)) {
                        error = true;
                    }
                    _this2.setState({
                        value: value,
                        error: error
                    }, function () {
                        (0, _rcJsUtils.exec)(onChange, _this2.state.value, _this2.state.error);
                    });
                });
            }
        }
        /**
         * Handle input onChange event.
         * @param  {function} handler=val=>val
         * @return {function} onChange event handler.
         */

    }, {
        key: 'onChange',
        value: function onChange() {
            var _this3 = this;

            var handler = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function (val) {
                return val;
            };

            return function (val) {
                var onChange = _this3.props.onChange;

                var value = (0, _rcJsUtils.exec)(handler, val);
                var error = false;
                if (!_this3.validate(value)) {
                    error = true;
                }
                _this3.setState({
                    value: value,
                    error: error
                }, function () {
                    (0, _rcJsUtils.exec)(onChange, _this3.state.value, _this3.state.error);
                });
            };
        }
    }]);

    return BasicComponent;
}(_react.Component);

exports.default = BasicComponent;