'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _select = require('antd/lib/select');

var _select2 = _interopRequireDefault(_select);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd/lib/select/style');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _BasicComponent2 = require('./BasicComponent');

var _BasicComponent3 = _interopRequireDefault(_BasicComponent2);

var _index = require('../index');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LOCALE = {
    zh: {
        notFoundContent: '暂无数据'
    },
    en: {
        notFoundContent: 'No Data'
    }
};
/**
 * Select component.
 * @name Select
 * @since 0.3.5
 * @author liujiali
 */

var Select = function (_BasicComponent) {
    _inherits(Select, _BasicComponent);

    function Select() {
        _classCallCheck(this, Select);

        return _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).apply(this, arguments));
    }

    _createClass(Select, [{
        key: 'componentDidUpdate',

        /**
         * componentDidUpdate hook function.
         * @param {any} prevProps - Previous props.
         * @private
         */
        value: function componentDidUpdate(prevProps) {
            if (prevProps.options !== this.props.options) {
                var options = this.props.options;
                var value = this.state.value;

                var currentValue = undefined;
                if ((0, _lodash.isArray)(value)) {
                    currentValue = [];
                    value.forEach(function (val) {
                        if (options.map(function (i) {
                            return i.value;
                        }).indexOf(val) !== -1) {
                            currentValue.push(val);
                        }
                    });
                    currentValue = currentValue.length ? currentValue : undefined;
                } else {
                    var currentOpt = (0, _lodash.find)(options, function (i) {
                        return i.value === value;
                    });
                    currentValue = currentOpt ? currentOpt.value : undefined;
                }
                this.setState({
                    value: currentValue
                });
            }
        }
        /**
         * Render method.
         * @return  {*} No return value.
         */

    }, {
        key: 'render',
        value: function render() {
            var _props$options = this.props.options,
                options = _props$options === undefined ? [] : _props$options;
            var _state = this.state,
                value = _state.value,
                error = _state.error;

            var settings = (0, _index.getDefaultSettings)();
            var locale = settings.locale;

            return _react2.default.createElement(
                _react.Fragment,
                null,
                _react2.default.createElement(
                    'div',
                    { className: error ? 'has-error' : '' },
                    _react2.default.createElement(
                        _select2.default,
                        _extends({ style: { width: '100%' }
                        }, this.props, { value: value, onChange: this.onChange(),
                            notFoundContent: LOCALE[locale].notFoundContent }),
                        options.map(function (opt, index) {
                            return _react2.default.createElement(
                                _select2.default.Option,
                                { value: opt.value, key: index },
                                opt.label
                            );
                        })
                    )
                )
            );
        }
    }]);

    return Select;
}(_BasicComponent3.default);

exports.default = Select;