'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _rcJsValidate = require('rc-js-validate');

var _rcJsValidate2 = _interopRequireDefault(_rcJsValidate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Input validate.
 * @param  {object} [options={}] - Validate options.
 * @return {boolean} validate result.
 */
function validateField() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var required = options.required,
        pattern = options.pattern,
        maxLen = options.maxLen;

    return function (value) {
        if (required && !_rcJsValidate2.default.required(value)) {
            return false;
        }
        if (pattern && !_rcJsValidate2.default.pattern(value, pattern)) {
            return false;
        }
        if (maxLen && !_rcJsValidate2.default.maxLen(value, maxLen)) {
            return false;
        }
        return true;
    };
}
exports.default = validateField;