'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _button = require('antd/lib/button');

var _button2 = _interopRequireDefault(_button);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('antd/lib/modal/style');

require('antd/lib/button/style');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LOCALE = {
    zh: {
        cancelButton: '取消'
    },
    en: {
        cancelButton: 'Cancel'
    }
};

/**
 * Help you to use antd Modal more conveniently.
 * @since 0.2.0
 * @author liujiali
 * @property {object} modal - `modal` props for injected component.
 * @property {showModal} modal.showModal - Show Modal function.
 * @property {function} modal.closeModal - Close Modal function.
 * @property {object} modal - `modal` props for Modal component.
 * @property {string} [modal.title] - Modal title.
 * @property {number} [modal.width] - Modal width.
 * @property {Array} [modal.footer] - Modal footer.The modal will always has `Cancel` button.
 * @example
 * // first inject to the component.
 * class Demo extends Component {
 *     ......
 * }
 * export default ModalHelper()(Demo);
 *
 * // then use `modal` in props to open the modal.
 * class Demo extends Component {
 *     handleAddClick() {
 *         const {modal} = this.props;
 *         modal.showModal({
 *             title: 'Add',
 *             width: 700,
 *             component: <AddModal />,
 *         });
 *     }
 * }
 *
 * // you can use `modal` props in modal component to set the Modal footer or control the modal close.
 * class AddModal extends Component {
 *     componentDidMount() {
 *         const {modal} = this.props;
 *         modal.footer = [
 *             <Button onClick={this.handleDoneClick}>Done</Button>
 *         ];
 *     }
 *     handleDoneClick = () => {
 *         const {modal} = this.props;
 *         modal.closeModal();
 *     }
 * }
 * @return {function} - Inject funtion.
 */
var ModalHelper = function ModalHelper() {
    return function (WrappedComponent) {
        /**
         * ModalHelper component.
         * @namespace ModalHelper
         * @description This component is used to use Modal but not write <Modal>
        */
        var ModalHelper = function (_Component) {
            _inherits(ModalHelper, _Component);

            /**
             * Create and initialize component.
             * @param {*} props - Component props.
             */
            function ModalHelper(props) {
                _classCallCheck(this, ModalHelper);

                var _this = _possibleConstructorReturn(this, (ModalHelper.__proto__ || Object.getPrototypeOf(ModalHelper)).call(this, props));

                _this.state = {
                    title: '',
                    showModal: false,
                    width: 500,
                    component: null,
                    footer: [],
                    // afterClose: null,

                    isDrag: false,
                    mousePageX: undefined,
                    mousePageY: undefined
                };
                return _this;
            }
            /**
             * Show modal.
             * @since 0.2.0
             * @author liujiali
             * @private
             * @return {function} Handle Modal open.
             */


            _createClass(ModalHelper, [{
                key: 'showModal',
                value: function showModal() {
                    var _this2 = this;

                    return function (option) {
                        _this2.setState({
                            showModal: true,
                            title: option.title,
                            width: option.width ? option.width : 500,
                            component: option.component ? option.component : null
                            // footer: footer,
                            // afterClose: option.afterClose ? option.afterClose : null
                        });
                    };
                }
                /**
                 * Hide modal.
                 * @since 0.2.0
                 * @author liujiali
                 * @private
                 * @return {function} Handle Modal close.
                 */

            }, {
                key: 'closeModal',
                value: function closeModal() {
                    var _this3 = this;

                    return function () {
                        _this3.setState({
                            showModal: false
                        });
                    };
                }
                /**
                 * Re-render the modal.
                 * @since 0.2.3
                 * @author liujiali
                 * @private
                 * @return {function} Handle Modal re-render.
                 */

            }, {
                key: 'reloadModal',
                value: function reloadModal() {
                    var _this4 = this;

                    return function () {
                        _this4.forceUpdate();
                    };
                }
                /**
                 * Get Modal dragable header.
                 * @since 0.2.0
                 * @author liujiali
                 * @private
                 * @return {function} Antd Modal title function.
                 */

            }, {
                key: 'getModalHeader',
                value: function getModalHeader() {
                    var style = {
                        padding: '12px 0 12px 24px',
                        margin: '-12px 0 -12px -24px'
                    };
                    return _react2.default.createElement(
                        'div',
                        { onMouseDown: this.handleDragMouseDown(),
                            onMouseMove: this.handleDragMouseMove(),
                            onMouseUp: this.handleDragMouseUp(),
                            onMouseLeave: this.handleDragMouseUp(),
                            style: style
                        },
                        this.state.title
                    );
                }
                /**
                 * Handle modal drag start.
                 * @since 0.2.0
                 * @author liujiali
                 * @private
                 * @return {function} Modal drag handler.
                 */

            }, {
                key: 'handleDragMouseDown',
                value: function handleDragMouseDown() {
                    var _this5 = this;

                    return function (e) {
                        // TODO: use class to locale the modal
                        var modalElement = e.target.parentElement.parentElement.parentElement;
                        _this5.setState(_extends({}, _this5.state, {
                            isDrag: true,
                            mousePageX: e.pageX - modalElement.offsetLeft,
                            mousePageY: e.pageY - modalElement.offsetTop
                        }));
                    };
                }
                /**
                 * Handle modal drag over.
                 * @since 0.2.0
                 * @author liujiali
                 * @private
                 * @return {function} Modal drag handler.
                 */

            }, {
                key: 'handleDragMouseUp',
                value: function handleDragMouseUp() {
                    var _this6 = this;

                    return function () {
                        _this6.setState(_extends({}, _this6.state, {
                            isDrag: false
                        }));
                    };
                }
                /**
                 * Handle modal drag move.
                 * @since 0.2.0
                 * @author liujiali
                 * @private
                 * @return {function} Modal drag handler.
                 */

            }, {
                key: 'handleDragMouseMove',
                value: function handleDragMouseMove() {
                    var _this7 = this;

                    return function (e) {
                        if (!_this7.state.isDrag) return;
                        var modalNode = e.target.parentElement.parentElement.parentElement;
                        var style = modalNode.style;

                        style.top = e.pageY - _this7.state.mousePageY + 'px';
                        style.left = e.pageX - _this7.state.mousePageX + 'px';
                    };
                }
                /**
                 * Get Modal child component.
                 * @since 0.2.0
                 * @author liujiali
                 * @private
                 * @param {function} component - Modal child component
                 * @return {ReactNode} Child component node.
                 */

            }, {
                key: 'getModalComponent',
                value: function getModalComponent(component) {
                    var _this8 = this;

                    if (!component || !component.type) return null;
                    var Component = component.type;
                    var props = component.props;

                    var modal = {
                        footer: [],
                        showModal: this.showModal(),
                        closeModal: this.closeModal(),
                        reload: this.reloadModal()
                    };
                    var modalProxy = new Proxy(modal, {
                        set: function set(target, propKey, value, receiver) {
                            _this8.setState(_defineProperty({}, propKey, value));
                            return true;
                        }
                    });
                    return _react2.default.createElement(Component, _extends({}, props, { modal: modalProxy }));
                }
                /**
                 * Render method.
                 * @since 0.2.0
                 * @author liujiali
                 * @private
                 * @return  {*} No return value.
                 */

            }, {
                key: 'render',
                value: function render() {
                    var _this9 = this;

                    var nextProps = _extends({}, this.props, {
                        modal: {
                            showModal: this.showModal(),
                            closeModal: this.closeModal(),
                            reload: this.reloadModal()
                        }
                    });
                    var component = this.getModalComponent(this.state.component);
                    var footer = this.state.footer;

                    var footers = footer.map(function (i) {
                        return i;
                    });
                    var settings = (0, _index.getDefaultSettings)();
                    var locale = settings.locale;

                    footers.push(_react2.default.createElement(
                        _button2.default,
                        { onClick: this.closeModal(),
                            key: 'cancel' },
                        LOCALE[locale].cancelButton
                    ));
                    return _react2.default.createElement(
                        _react.Fragment,
                        null,
                        _react2.default.createElement(WrappedComponent, nextProps),
                        _react2.default.createElement(
                            _modal2.default,
                            { title: this.getModalHeader(),
                                visible: this.state.showModal,
                                footer: footers,
                                destroyOnClose: true,
                                maskClosable: false,
                                width: this.state.width,
                                onCancel: function onCancel() {
                                    return _this9.closeModal()();
                                } },
                            component
                        )
                    );
                }
            }]);

            return ModalHelper;
        }(_react.Component);

        return ModalHelper;
    };
};

exports.default = ModalHelper;

/**
 * showModal method description.
 * @callback showModal
 * @since 0.2.0
 * @author liujiali
 * @param {object} option - Modal option.
 * @param {string|ReactNode} [option.title] - Modal title.
 * @param {number} [option.width=500] - Modal width.
 * @param {ReactNode} option.component - Modal component.
 */