'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _DataList = require('./DataList');

Object.defineProperty(exports, 'DataList', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_DataList).default;
    }
});

var _ModalHelper = require('./ModalHelper');

Object.defineProperty(exports, 'ModalHelper', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_ModalHelper).default;
    }
});

var _Form = require('./Form');

Object.defineProperty(exports, 'Form', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_Form).default;
    }
});

var _Detail = require('./Detail');

Object.defineProperty(exports, 'Detail', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_Detail).default;
    }
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultSettings = {
    locale: navigator.language === 'zh-CN' ? 'zh' : 'en'
};
/**
 * Set rc-ui-component settings.
 * @param {object} settings - rc-ui-component settings.
 * @param {enum} [settings.locale] - rc-ui-component text locale.<br/>[`zh`, `en`].
 */
function setDefaultSettings(settings) {
    defaultSettings = Object.assign(defaultSettings, settings);
}
/**
 * Get rc-ui-component settings.
 * @return {object} rc-ui-component settings.
 */
function getDefaultSettings() {
    return defaultSettings;
}

exports.setDefaultSettings = setDefaultSettings;
exports.getDefaultSettings = getDefaultSettings;